searchNodes=[{"ref":"Bookings.Application.html","title":"Bookings.Application","type":"module","doc":""},{"ref":"Bookings.Application.html#start/2","title":"Bookings.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Bookings.Core.DateTimeFormatter.html","title":"Bookings.Core.DateTimeFormatter","type":"module","doc":""},{"ref":"Bookings.Core.DateTimeFormatter.html#format_iso_date_time/2","title":"Bookings.Core.DateTimeFormatter.format_iso_date_time/2","type":"function","doc":""},{"ref":"Bookings.MessageProcessors.CancelBookingMessageProcessor.html","title":"Bookings.MessageProcessors.CancelBookingMessageProcessor","type":"module","doc":""},{"ref":"Bookings.MessageProcessors.CancelBookingMessageProcessor.html#process_message/2","title":"Bookings.MessageProcessors.CancelBookingMessageProcessor.process_message/2","type":"function","doc":"Processes *.cancel_booking messages from the airline_request exchange. Calls a 3rd party API to cancel a booking, removes the booking from Bookings.Store."},{"ref":"Bookings.MessageProcessors.CancelBookingMessageProcessor.html#t:error/0","title":"Bookings.MessageProcessors.CancelBookingMessageProcessor.error/0","type":"type","doc":""},{"ref":"Bookings.MessageProcessors.PlaceBookingMessageProcessor.html","title":"Bookings.MessageProcessors.PlaceBookingMessageProcessor","type":"module","doc":""},{"ref":"Bookings.MessageProcessors.PlaceBookingMessageProcessor.html#process_message/2","title":"Bookings.MessageProcessors.PlaceBookingMessageProcessor.process_message/2","type":"function","doc":"Processes *.place_booking messages from the airline_request exchange. Calls a 3rd party API to place a booking, saves the booking into Bookings.Store."},{"ref":"Bookings.MessageProcessors.PlaceBookingMessageProcessor.html#t:error/0","title":"Bookings.MessageProcessors.PlaceBookingMessageProcessor.error/0","type":"type","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.html","title":"Bookings.Producers.AirlineRequestProducer","type":"module","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.html#cancel_booking/3","title":"Bookings.Producers.AirlineRequestProducer.cancel_booking/3","type":"function","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.html#place_booking/3","title":"Bookings.Producers.AirlineRequestProducer.place_booking/3","type":"function","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.html#publish/2","title":"Bookings.Producers.AirlineRequestProducer.publish/2","type":"function","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.html#start_link/1","title":"Bookings.Producers.AirlineRequestProducer.start_link/1","type":"function","doc":""},{"ref":"Bookings.Producers.AirlineRequestProducer.State.html","title":"Bookings.Producers.AirlineRequestProducer.State","type":"module","doc":""},{"ref":"Bookings.Store.html","title":"Bookings.Store","type":"module","doc":""},{"ref":"Bookings.Store.html#child_spec/1","title":"Bookings.Store.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bookings.Store.html#delete/1","title":"Bookings.Store.delete/1","type":"function","doc":""},{"ref":"Bookings.Store.html#delete_all/0","title":"Bookings.Store.delete_all/0","type":"function","doc":""},{"ref":"Bookings.Store.html#get_all/0","title":"Bookings.Store.get_all/0","type":"function","doc":""},{"ref":"Bookings.Store.html#get_existing/1","title":"Bookings.Store.get_existing/1","type":"function","doc":""},{"ref":"Bookings.Store.html#insert/1","title":"Bookings.Store.insert/1","type":"function","doc":""},{"ref":"Bookings.Store.html#start_link/1","title":"Bookings.Store.start_link/1","type":"function","doc":""},{"ref":"Bookings.Store.State.html","title":"Bookings.Store.State","type":"module","doc":""},{"ref":"Bookings.Topology.html","title":"Bookings.Topology","type":"module","doc":""},{"ref":"Bookings.Topology.html#gen/0","title":"Bookings.Topology.gen/0","type":"function","doc":"Callback implementation for MQ.Topology.gen/0."},{"ref":"Core.DateTime.html","title":"Core.DateTime","type":"module","doc":"Contains DateTime convenience methods."},{"ref":"Core.DateTime.html#now_unix/1","title":"Core.DateTime.now_unix/1","type":"function","doc":"Returns current time as a unix timestamp. The time unit is :millisecond by default."},{"ref":"Core.ExponentialBackoff.html","title":"Core.ExponentialBackoff","type":"module","doc":""},{"ref":"Core.ExponentialBackoff.html#with_backoff/1","title":"Core.ExponentialBackoff.with_backoff/1","type":"function","doc":""},{"ref":"Core.LogFormatter.html","title":"Core.LogFormatter","type":"module","doc":"Useful log formatter, outputs JSON in prod."},{"ref":"Core.Name.html","title":"Core.Name","type":"module","doc":""},{"ref":"Core.Name.html#child_spec_id/0","title":"Core.Name.child_spec_id/0","type":"function","doc":""},{"ref":"Core.Name.html#module_to_snake_case/1","title":"Core.Name.module_to_snake_case/1","type":"function","doc":""},{"ref":"Core.Name.html#random_id/0","title":"Core.Name.random_id/0","type":"function","doc":""},{"ref":"Core.Name.html#unique_worker_name/1","title":"Core.Name.unique_worker_name/1","type":"function","doc":""},{"ref":"MQ.AMQPConfig.html","title":"MQ.AMQPConfig","type":"module","doc":""},{"ref":"MQ.AMQPConfig.html#config/0","title":"MQ.AMQPConfig.config/0","type":"function","doc":""},{"ref":"MQ.AMQPConfig.html#topology/0","title":"MQ.AMQPConfig.topology/0","type":"function","doc":""},{"ref":"MQ.AMQPConfig.html#url/0","title":"MQ.AMQPConfig.url/0","type":"function","doc":""},{"ref":"MQ.ChannelRegistry.html","title":"MQ.ChannelRegistry","type":"module","doc":""},{"ref":"MQ.ChannelRegistry.html#delete/1","title":"MQ.ChannelRegistry.delete/1","type":"function","doc":""},{"ref":"MQ.ChannelRegistry.html#init/0","title":"MQ.ChannelRegistry.init/0","type":"function","doc":""},{"ref":"MQ.ChannelRegistry.html#insert/2","title":"MQ.ChannelRegistry.insert/2","type":"function","doc":""},{"ref":"MQ.ChannelRegistry.html#lookup/1","title":"MQ.ChannelRegistry.lookup/1","type":"function","doc":""},{"ref":"MQ.ConnectionManager.html","title":"MQ.ConnectionManager","type":"module","doc":""},{"ref":"MQ.ConnectionManager.html#child_spec/1","title":"MQ.ConnectionManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"MQ.ConnectionManager.html#close_channel/1","title":"MQ.ConnectionManager.close_channel/1","type":"function","doc":""},{"ref":"MQ.ConnectionManager.html#request_channel/1","title":"MQ.ConnectionManager.request_channel/1","type":"function","doc":""},{"ref":"MQ.ConnectionManager.html#request_confirm_channel/1","title":"MQ.ConnectionManager.request_confirm_channel/1","type":"function","doc":"See https://hexdocs.pm/amqp/AMQP.Confirm.html for more details."},{"ref":"MQ.ConnectionManager.html#start_link/1","title":"MQ.ConnectionManager.start_link/1","type":"function","doc":""},{"ref":"MQ.ConnectionManager.State.html","title":"MQ.ConnectionManager.State","type":"module","doc":""},{"ref":"MQ.Consumer.html","title":"MQ.Consumer","type":"module","doc":""},{"ref":"MQ.Consumer.html#child_spec/1","title":"MQ.Consumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"MQ.Consumer.html#start_link/1","title":"MQ.Consumer.start_link/1","type":"function","doc":""},{"ref":"MQ.Consumer.State.html","title":"MQ.Consumer.State","type":"module","doc":""},{"ref":"MQ.ConsumerPool.html","title":"MQ.ConsumerPool","type":"module","doc":""},{"ref":"MQ.ConsumerPool.html#child_spec/1","title":"MQ.ConsumerPool.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"MQ.ConsumerPool.html#start_link/1","title":"MQ.ConsumerPool.start_link/1","type":"function","doc":""},{"ref":"MQ.Producer.html","title":"MQ.Producer","type":"module","doc":""},{"ref":"MQ.Producer.html#add_default_metadata/1","title":"MQ.Producer.add_default_metadata/1","type":"function","doc":""},{"ref":"MQ.Producer.html#get_routing_key_from_opts/1","title":"MQ.Producer.get_routing_key_from_opts/1","type":"function","doc":""},{"ref":"MQ.Supervisor.html","title":"MQ.Supervisor","type":"module","doc":""},{"ref":"MQ.Supervisor.html#child_spec/1","title":"MQ.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"MQ.Supervisor.html#start_link/1","title":"MQ.Supervisor.start_link/1","type":"function","doc":""},{"ref":"MQ.Topology.html","title":"MQ.Topology","type":"behaviour","doc":"Defines the behaviour that the topology config needs to implement."},{"ref":"MQ.Topology.html#c:gen/0","title":"MQ.Topology.gen/0","type":"callback","doc":""},{"ref":"MQ.Topology.html#t:exchange/0","title":"MQ.Topology.exchange/0","type":"type","doc":""},{"ref":"MQ.Topology.Config.html","title":"MQ.Topology.Config","type":"module","doc":""},{"ref":"MQ.Topology.Config.html#dlq_args/1","title":"MQ.Topology.Config.dlq_args/1","type":"function","doc":""},{"ref":"MQ.Topology.Config.html#gen/0","title":"MQ.Topology.Config.gen/0","type":"function","doc":""},{"ref":"MQ.Topology.Config.DeadLetterQueueConfig.html","title":"MQ.Topology.Config.DeadLetterQueueConfig","type":"module","doc":""},{"ref":"MQ.Topology.Config.QueueConfig.html","title":"MQ.Topology.Config.QueueConfig","type":"module","doc":""},{"ref":"MQ.Topology.Config.TopicExchangeConfig.html","title":"MQ.Topology.Config.TopicExchangeConfig","type":"module","doc":""},{"ref":"MQ.Topology.Queue.html","title":"MQ.Topology.Queue","type":"module","doc":""},{"ref":"MQ.Topology.Queue.html#purge_all/1","title":"MQ.Topology.Queue.purge_all/1","type":"function","doc":""},{"ref":"MQ.Topology.Setup.html","title":"MQ.Topology.Setup","type":"module","doc":"Use to perform a one-off setup of exchanges and queues for dev and test environments."},{"ref":"MQ.Topology.Setup.html#run/0","title":"MQ.Topology.Setup.run/0","type":"function","doc":""},{"ref":"MQ.Topology.Setup.Result.html","title":"MQ.Topology.Setup.Result","type":"module","doc":""},{"ref":"Mix.Tasks.Rabbit.Init.html","title":"Mix.Tasks.Rabbit.Init","type":"task","doc":""},{"ref":"Mix.Tasks.Rabbit.Init.html#run/1","title":"Mix.Tasks.Rabbit.Init.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."}]